﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class gameTriggers : MonoBehaviour
{
    private int dayCounter=1;
    private int timeCounter = 0;
    private int doorCounter;
    private int stoveCounter;
    private int fridgeCounter;
    private int cleanCounter;
    private int bedCounter;
    private int winCounter = -1;
    bool paused = false;
    public GameObject camera;   //import this to access its sound and change the background music
    public GameObject thePlayer;
    public GameObject fridgeZone;
    public GameObject bedZone;
    public GameObject cleanZone;
    public GameObject doorZone;
    public GameObject stoveZone;
    public GameObject pauseScreen;
    public GameObject textBubble;
    public GameObject portrait;
    public Sprite d2TextGood;
    public Sprite d3TextGood;
    public Sprite d4TextGood;
    public Sprite d5TextGood;
    public Sprite d2TextBad;
    public Sprite d3TextBad;
    public Sprite d4TextBad;
    public Sprite d5TextBad;
    public AudioClip doorNoise;
    bool doorNoisePlay;
    bool doorNoiseToggleChange;
    public AudioClip zipperNoise;
    bool zipperNoisePlay;
    bool zipperNoiseToggleChange;
    public AudioClip textMsgNoise;
    bool textNoisePlay;
    bool textNoiseToggleChange;
    public AudioClip fridgeNoise;
    bool fridgeNoisePlay;
    bool fridgeNoiseToggleChange;
    public AudioClip cleanNoise;
    bool cleanNoisePlay;
    bool cleanNoiseToggleChange;
    public AudioClip stoveNoise;
    bool stoveNoisePlay;
    bool stoveNoiseToggleChange;
    public AudioClip footstepsNoise;
    bool footstepNoisePlay;
    bool footstepNoiseToggleChange;
    public AudioClip musicHappy;
    bool musicHappyPlay;
    bool musicHappyToggleChange;
    public AudioClip musicNeutral;
    bool musicNeutralPlay;
    bool musicNeutralToggleChange;
    public AudioClip musicSad;
    bool musicSadPlay;
    bool musicSadToggleChange;


    // Start is called before the first frame update
    void Start()
    {
        
    }

    // Update is called once per frame
    void Update()
    {
        if (timeCounter == 0)
        {
            pauseToggle();
        }
        if (Input.GetKeyDown(KeyCode.R))
        {
            UnityEngine.SceneManagement.SceneManager.LoadScene(0);
        }
        if (Input.GetKeyDown(KeyCode.Z))
        {
            pauseToggle();
        }
        if (Input.GetKeyDown(KeyCode.Q))
        {
            Application.Quit();
        }
        timeCounter++;
        if(timeCounter == 5)
        {
            Debug.Log("It is Day #" + dayCounter);
        }
        dayAfterDay(); 
    }
    
    private void OnTriggerStay(Collider other)
    {
        if (other == bedZone.GetComponent<Collider>())
        {
            Debug.Log("Staying by collider near bed" );
            bedCounter++;
        }
        else if(other == fridgeZone.GetComponent<Collider>())
        {
            Debug.Log("Staying by a collider near fridge");
            fridgeCounter++;
        }
        else if (other == cleanZone.GetComponent<Collider>())
        {
            Debug.Log("Staying by collider near living room");
            cleanCounter++;
        }
        else if (other == doorZone.GetComponent<Collider>())
        {
            Debug.Log("Staying by collider near door");
            doorCounter++;
        }
        else if(other == stoveZone.GetComponent<Collider>())
        {
            Debug.Log("Staying by collider by stove");
            stoveCounter++;
        }
        else
        {
            Debug.Log("Staying by a different collider");
        }   
    }

    private void OnTriggerEnter(Collider other)   
    {
        if (other == bedZone.GetComponent<Collider>())
        {
            Debug.Log("Entered a collider near bed");
        }
        else if (other == fridgeZone.GetComponent<Collider>())
        {
            Debug.Log("Entered a collider near fridge");
            if (dayCounter == 3)
            {
                thePlayer.GetComponent<AudioSource>().clip = fridgeNoise;
                thePlayer.GetComponent<AudioSource>().Play();
            }
        }
        else if (other == cleanZone.GetComponent<Collider>())
        {
            Debug.Log("Entered collider near living room");
            if (dayCounter == 4)
            {
                thePlayer.GetComponent<AudioSource>().clip = cleanNoise;
                thePlayer.GetComponent<AudioSource>().Play();
            }
        }
        else if (other == doorZone.GetComponent<Collider>())
        {
            Debug.Log("Entered collider near door");
            if (dayCounter == 5)
            {
                thePlayer.GetComponent<AudioSource>().clip = doorNoise;
                thePlayer.GetComponent<AudioSource>().Play();
            }
        }
        else if (other == stoveZone.GetComponent<Collider>())
        {
            thePlayer.GetComponent<AudioSource>().clip = stoveNoise;
            thePlayer.GetComponent<AudioSource>().Play();
            Debug.Log("Entered collider by stove");
        }
        else
        {
            Debug.Log("Entered a different collider");
        }
    }

    private void OnTriggerExit(Collider other)
    {
        if (other == bedZone.GetComponent<Collider>())
        {
            Debug.Log("Left a collider near bed");
        }
        else if (other == fridgeZone.GetComponent<Collider>())
        {
            Debug.Log("Left a collider near fridge");
            if (dayCounter == 3)
            {
                thePlayer.GetComponent<AudioSource>().clip = footstepsNoise;
                thePlayer.GetComponent<AudioSource>().Play();
            }
        }
        else if (other == cleanZone.GetComponent<Collider>())
        {
            Debug.Log("Left collider near living room");
            if (dayCounter == 4)
            {
                thePlayer.GetComponent<AudioSource>().clip = footstepsNoise;
                thePlayer.GetComponent<AudioSource>().Play();
            }
        }
        else if (other == doorZone.GetComponent<Collider>())
        {
            Debug.Log("Left collider near door");
        }
        else if (other == stoveZone.GetComponent<Collider>())
        {
            Debug.Log("Left collider by stove");
            thePlayer.GetComponent<AudioSource>().clip = footstepsNoise;
            thePlayer.GetComponent<AudioSource>().Play();
        }
        else
        {
            Debug.Log("Left a different collider");
        }
    }

    void dayAfterDay()
    {
        
        if (dayCounter == 1)
        {

            if (timeCounter >= 750)
            {

                if (bedCounter >= stoveCounter + 100)
                {
                    winCounter--;
                    timeCounter = 0;
                    doorCounter = 0;
                    fridgeCounter = 0;
                    stoveCounter = 0;
                    cleanCounter = 0;
                    bedCounter = 0;
                    Debug.Log("Day 1 ends poorly");
                    dayCounter++;
                }
                else if(bedCounter <= stoveCounter + 100){
                    winCounter++;
                    timeCounter = 0;
                    doorCounter = 0;
                    fridgeCounter = 0;
                    stoveCounter = 0;
                    cleanCounter = 0;
                    bedCounter = 0;
                    Debug.Log("Day 1 ends well");
                    dayCounter++;
                }
            }
        }
        else if (dayCounter == 2)
        {
            if (winCounter >= 0)
            {
                textBubble.GetComponent<SpriteRenderer>().sprite = d2TextGood;
            }
            else if (winCounter < 0)
            {
                textBubble.GetComponent<SpriteRenderer>().sprite = d2TextBad;
            }

            if (timeCounter >= 1200)
            {
                if (bedCounter >= stoveCounter + 100)
                {
                    winCounter--;
                    timeCounter = 0;
                    doorCounter = 0;
                    fridgeCounter = 0;
                    stoveCounter = 0;
                    cleanCounter = 0;
                    bedCounter = 0;
                    Debug.Log("Day 2 ends poorly");
                    dayCounter++;
                }
                else if (bedCounter <= stoveCounter + 100)
                {
                    winCounter++;
                    timeCounter = 0;
                    doorCounter = 0;
                    fridgeCounter = 0;
                    stoveCounter = 0;
                    cleanCounter = 0;
                    bedCounter = 0;
                    Debug.Log("Day 2 ends well");
                    dayCounter++;
                }
            }
        }
        else if (dayCounter == 3)
        {
            if (winCounter >= 0)
            {
                textBubble.GetComponent<SpriteRenderer>().sprite = d3TextGood;
            }
            else if (winCounter < 0)
            {
                textBubble.GetComponent<SpriteRenderer>().sprite = d3TextBad;
            }

            if (timeCounter >= 1200)
            {
                if (bedCounter >= stoveCounter + fridgeCounter + 100)
                {
                    winCounter--;
                    timeCounter = 0;
                    doorCounter = 0;
                    fridgeCounter = 0;
                    stoveCounter = 0;
                    cleanCounter = 0;
                    bedCounter = 0;
                    Debug.Log("Day 3 ends poorly");
                    dayCounter++;
                }
                else if (bedCounter <= stoveCounter + fridgeCounter + 100)
                {
                    winCounter++;
                    timeCounter = 0;
                    doorCounter = 0;
                    fridgeCounter = 0;
                    stoveCounter = 0;
                    cleanCounter = 0;
                    bedCounter = 0;
                    Debug.Log("Day 3 ends well");
                    dayCounter++;
                }
            }
        }
        else if (dayCounter == 4)
        {
            if (winCounter >= 0)
            {
                textBubble.GetComponent<SpriteRenderer>().sprite = d4TextGood;
            }
            else if (winCounter < 0)
            {
                textBubble.GetComponent<SpriteRenderer>().sprite = d4TextBad;
            }

            if (timeCounter >= 1200)
            {
                if (bedCounter >= stoveCounter + cleanCounter + 100)
                {
                    winCounter--;
                    timeCounter = 0;
                    doorCounter = 0;
                    fridgeCounter = 0;
                    stoveCounter = 0;
                    cleanCounter = 0;
                    bedCounter = 0;
                    Debug.Log("Day 4 ends poorly");
                    dayCounter++;
                }
                else if (bedCounter <= stoveCounter + cleanCounter + 100)
                {
                    winCounter++;
                    timeCounter = 0;
                    doorCounter = 0;
                    fridgeCounter = 0;
                    stoveCounter = 0;
                    cleanCounter = 0;
                    bedCounter = 0;
                    Debug.Log("Day 4 ends well");
                    dayCounter++;
                }
            }
        }
        else if (dayCounter == 5)
        {
            if (winCounter >= 0)
            {
                textBubble.GetComponent<SpriteRenderer>().sprite = d4TextGood;
            }
            else if (winCounter < 0)
            {
                textBubble.GetComponent<SpriteRenderer>().sprite = d2TextBad;
            }
            if (doorCounter > 5)     //on the Last day, if you choose to go and see them the scene immediately ends
            {
                winCounter++;
                timeCounter = 0;
                doorCounter = 0;
                fridgeCounter = 0;
                stoveCounter = 0;
                cleanCounter = 0;
                bedCounter = 0;
                Debug.Log("Day 5 ends well");
                dayCounter++;
            }
            if (timeCounter >= 1200)
            {
                if (bedCounter >= doorCounter + fridgeCounter + cleanCounter + stoveCounter + 100)
                {
                    winCounter--;
                    timeCounter = 0;
                    doorCounter = 0;
                    fridgeCounter = 0;
                    stoveCounter = 0;
                    cleanCounter = 0;
                    bedCounter = 0;
                    Debug.Log("Day 5 ends poorly");
                    dayCounter++;
                }
                else if (bedCounter <= doorCounter + fridgeCounter + cleanCounter + stoveCounter + 100)
                {
                    winCounter++;
                    timeCounter = 0;
                    doorCounter = 0;
                    fridgeCounter = 0;
                    stoveCounter = 0;
                    cleanCounter = 0;
                    bedCounter = 0;
                    Debug.Log("Day 5 ends well");
                    dayCounter++;
                }
            }
        }

        else if (dayCounter > 5)
        {
            portrait.transform.position = new Vector3(0f, 0f, 601f);
        
            if (winCounter >= 0)
            {
                textBubble.GetComponent<SpriteRenderer>().sprite = d5TextGood;
            }
            else if (winCounter < 0)
            {
                textBubble.GetComponent<SpriteRenderer>().sprite = d5TextBad;
            }
            if (Input.anyKeyDown)
            {
                UnityEngine.SceneManagement.SceneManager.LoadScene(0);
            }

        }

    }

    public void pauseToggle()
    {
        if (Time.timeScale > 0)
        {
            Time.timeScale = 0;
            pauseScreen.transform.position = new Vector3(0f, 0f, -90f);
            textBubble.transform.position = new Vector3(-1.58f, 2.39f, -99f);
            thePlayer.GetComponent<AudioSource>().clip = doorNoise;
            thePlayer.GetComponent<AudioSource>().PlayOneShot(doorNoise);

                thePlayer.GetComponent<AudioSource>().clip = zipperNoise;
                thePlayer.GetComponent<AudioSource>().PlayOneShot(zipperNoise);
           

                thePlayer.GetComponent<AudioSource>().clip = textMsgNoise;
                thePlayer.GetComponent<AudioSource>().PlayOneShot(textMsgNoise);
           


        }
        else if (Time.timeScale == 0)
        {
            Time.timeScale = 1;
            pauseScreen.transform.position = new Vector3(0f, 0f, 600f);
            textBubble.transform.position = new Vector3(0f, 0f, 599f);
            thePlayer.GetComponent<AudioSource>().clip = footstepsNoise;
            thePlayer.GetComponent<AudioSource>().Play();
        }
    }
}
